Index: LMDZ4/trunk/libf/phylmd/interface_surf.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/interface_surf.F90	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/interface_surf.F90	(revision 776)
@@ -88,5 +88,5 @@
 
 
-   USE dimphy,only : monocpu,jjphy_nb,omp_rank
+   USE mod_phys_lmdz_para
 ! Cette routine sert d'aiguillage entre l'atmosphere et la surface en general 
 ! (sols continentaux, oceans, glaces) pour les fluxs de chaleur et d'humidite.
@@ -429,5 +429,5 @@
 
 !!$PB
-      ALLOCATE (tmp_rriv(iim,jjphy_nb), stat=error)
+      ALLOCATE (tmp_rriv(iim,jj_nb), stat=error)
       if (error /= 0) then
         abort_message='Pb allocation tmp_rriv'
@@ -435,5 +435,5 @@
       endif
       tmp_rriv=0.
-      ALLOCATE (tmp_rcoa(iim,jjphy_nb), stat=error)
+      ALLOCATE (tmp_rcoa(iim,jj_nb), stat=error)
       if (error /= 0) then
         abort_message='Pb allocation tmp_rcoa'
@@ -442,5 +442,5 @@
       tmp_rcoa=0.
 !ym      ALLOCATE (tmp_rlic(iim,jjm+1), stat=error)
-      ALLOCATE (tmp_rlic(iim,jjphy_nb), stat=error)
+      ALLOCATE (tmp_rlic(iim,jj_nb), stat=error)
       if (error /= 0) then
         abort_message='Pb allocation tmp_rlic'
@@ -1034,5 +1034,6 @@
 
   USE intersurf
-  USE dimphy, klon_x=>klon
+  USE mod_grid_phy_lmdz
+  USE mod_phys_lmdz_para
   IMPLICIT NONE
 ! Cette routine sert d'interface entre le modele atmospherique et le 
@@ -1175,5 +1176,5 @@
   integer :: jjb,jje,ijb,ije
   INTEGER,SAVE :: offset
-  REAL, dimension(klon2) :: rlon_g,rlat_g
+  REAL, dimension(klon_glo) :: rlon_g,rlat_g
   INTEGER, SAVE          :: orch_comm
 #include "temps.inc"
@@ -1245,8 +1246,8 @@
 
     
-    Call GatherField(rlon,rlon_g,1)
-    Call GatherField(rlat,rlat_g,1)
-
-    IF (phy_rank==0) THEN
+    CALL Gather(rlon,rlon_g)
+    CALL Gather(rlat,rlat_g)
+
+    IF (is_mpi_root) THEN
       index = 1
       do jj = 2, jjm
@@ -1260,5 +1261,5 @@
      lat_scat(:,1) = rlat_g(1)
      lon_scat(:,jjm+1) = lon_scat(:,2)
-     lat_scat(:,jjm+1) = rlat_g(klon2)
+     lat_scat(:,jjm+1) = rlat_g(klon_glo)
    ENDIF
    
@@ -1345,6 +1346,4 @@
 !    offset=offset-MOD(offset,iim)
 !  endif
-  
-  PRINT *,'ORCHIDEE ------> KNON : ',knon
   
    
@@ -1395,8 +1394,8 @@
     bidule=0.
     bidule(1:knon)=riverflow(1:knon)
-    call gath2cpl(bidule, tmp_rriv, klon, knon,iim,jjphy_nb,knindex)
+    call gath2cpl(bidule, tmp_rriv, klon, knon,iim,jj_nb,knindex)
     bidule=0.
     bidule(1:knon)=coastalflow(1:knon)
-    call gath2cpl(bidule, tmp_rcoa, klon, knon,iim,jjphy_nb,knindex)
+    call gath2cpl(bidule, tmp_rcoa, klon, knon,iim,jj_nb,knindex)
     alb_new(1:knon) = albedo_out(1:knon,1) 
     alblw(1:knon) = albedo_out(1:knon,2)
@@ -1414,5 +1413,6 @@
   
   SUBROUTINE Init_orchidee_index(iim,knon,orch_comm,knindex,offset,ktindex)
-  USE dimphy
+  USE mod_phys_lmdz_para, ONLY : is_parallel
+  
   IMPLICIT NONE
     INTEGER,INTENT(IN)  :: iim
@@ -1435,5 +1435,5 @@
     MyLastPoint=klon_begin-1+knindex(knon)+iim-1
 
-    IF (.NOT. monocpu) THEN
+    IF (is_parallel) THEN
 #ifdef CPP_PARA    
       call MPI_COMM_SIZE(orch_comm,mpi_size,ierr)
@@ -1445,5 +1445,5 @@
     ENDIF
     
-    IF (.NOT. monocpu) THEN
+    IF (is_parallel) THEN
       IF (mpi_rank /= 0) then
 #ifdef CPP_PARA
@@ -1472,8 +1472,6 @@
   
   SUBROUTINE Get_orchidee_communicator(knon,orch_comm)
-  USE dimphy, only : phy_rank
-#ifdef CPP_PARA
-  USE parallel, only : COMM_LMDZ
-#endif
+  USE mod_phys_lmdz_para, ONLY: mpi_rank, COMM_LMDZ_PHY
+
   IMPLICIT NONE
 #ifdef CPP_PARA
@@ -1493,5 +1491,5 @@
 
 #ifdef CPP_PARA    
-    CALL MPI_COMM_SPLIT(COMM_LMDZ,color,phy_rank,orch_comm,ierr)
+    CALL MPI_COMM_SPLIT(COMM_LMDZ_PHY,color,mpi_rank,orch_comm,ierr)
 #endif
     
@@ -1500,9 +1498,8 @@
     
   SUBROUTINE Init_neighbours(iim,jjm,knon,neighbours,ktindex,pctsrf)
-#ifdef CPP_PARA
-  USE parallel,only : COMM_LMDZ
-#endif
+  USE mod_phys_lmdz_para, not_use_mpi_root=>mpi_root
   USE dimphy
   IMPLICIT NONE
+
 #ifdef CPP_PARA
   include 'mpif.h'
@@ -1514,6 +1511,6 @@
   REAL :: pctsrf(klon)
   
-  INTEGER :: knon_nb(0:phy_size-1)
-  INTEGER,DIMENSION(0:phy_size-1) :: displs,sendcount
+  INTEGER :: knon_nb(0:mpi_size-1)
+  INTEGER,DIMENSION(0:mpi_size-1) :: displs,sendcount
   INTEGER,ALLOCATABLE :: ktindex_g(:)
   REAL*8  :: pctsrf_g(klon2)
@@ -1526,15 +1523,15 @@
   INTEGER :: ktindex_p(knon)
 
-  IF (monocpu) THEN
+  IF (is_sequential) THEN
     knon_nb(:)=knon
   ELSE  
 
 #ifdef CPP_PARA  
-    CALL MPI_GATHER(knon,1,MPI_INTEGER,knon_nb,1,MPI_INTEGER,0,COMM_LMDZ,ierr)
+    CALL MPI_GATHER(knon,1,MPI_INTEGER,knon_nb,1,MPI_INTEGER,0,COMM_LMDZ_PHY,ierr)
 #endif
   
   ENDIF
     
-  IF (phy_rank==0) THEN
+  IF (is_mpi_root) THEN
     knon_g=sum(knon_nb(:))
     ALLOCATE(ktindex_g(knon_g))
@@ -1542,5 +1539,5 @@
     neighbours_g(:,:)=-1
     displs(0)=0
-    DO i=1,phy_size-1
+    DO i=1,mpi_size-1
       displs(i)=displs(i-1)+knon_nb(i-1)
     ENDDO  
@@ -1549,17 +1546,17 @@
   ktindex_p(:)=ktindex(:)+klon_begin-1+iim-1
 
-  IF (monocpu) THEN
+  IF (is_sequential) THEN
     ktindex_g(:)=ktindex_p(:)
   ELSE
 
 #ifdef CPP_PARA  
-    CALL MPI_GATHERV(ktindex_p,knon,MPI_INTEGER,ktindex_g,knon_nb,displs,MPI_INTEGER,0,COMM_LMDZ,ierr)
+    CALL MPI_GATHERV(ktindex_p,knon,MPI_INTEGER,ktindex_g,knon_nb,displs,MPI_INTEGER,0,COMM_LMDZ_PHY,ierr)
 #endif
 
   ENDIF
      
-  CALL GatherField(pctsrf,pctsrf_g,1)
+  CALL Gather(pctsrf,pctsrf_g)
   
-  IF (phy_rank==0) THEN
+  IF (is_mpi_root) THEN
 !  Initialisation des offset    
 !
@@ -1615,9 +1612,9 @@
   
   DO i=1,8
-    IF (monocpu) THEN
+    IF (is_sequential) THEN
       neighbours(:,i)=neighbours_g(:,i)
     ELSE
 #ifdef CPP_PARA
-    CALL MPI_SCATTERV(neighbours_g(:,i),knon_nb,displs,MPI_INTEGER,neighbours(:,i),knon,MPI_INTEGER,0,COMM_LMDZ,ierr) 
+    CALL MPI_SCATTERV(neighbours_g(:,i),knon_nb,displs,MPI_INTEGER,neighbours(:,i),knon,MPI_INTEGER,0,COMM_LMDZ_PHY,ierr) 
 #endif
     ENDIF
@@ -1642,9 +1639,8 @@
 
    USE ioipsl
-   USE dimphy, only : jjphy_nb, iiphy_begin,iiphy_end,phy_rank,phy_size, monocpu
+   USE mod_phys_lmdz_para, not_use_mpi_root=>mpi_root
+   
    USE iophy
-#ifdef CPP_PARA
-   USE parallel, only: pole_nord,pole_sud,COMM_LMDZ
-#endif
+
 #ifdef CPP_PSMILE
    USE oasis
@@ -1774,12 +1770,12 @@
 !ym  REAL, DIMENSION(iim, jjm+1) :: tmp_lon, tmp_lat
 
-  real, dimension(iim, jjphy_nb) :: wri_sol_ice, wri_sol_sea, wri_nsol_ice 
-  real, dimension(iim, jjphy_nb) :: wri_nsol_sea, wri_fder_ice, wri_evap_ice
-  REAL, DIMENSION(iim, jjphy_nb) :: wri_evap_sea, wri_rcoa, wri_rriv
-  REAL, DIMENSION(iim, jjphy_nb) :: wri_rain, wri_snow, wri_taux, wri_tauy
-  REAL, DIMENSION(iim, jjphy_nb) :: wri_calv
-  REAL, DIMENSION(iim, jjphy_nb) :: wri_tauxx, wri_tauyy, wri_tauzz
-  REAL, DIMENSION(iim, jjphy_nb) :: tmp_lon, tmp_lat
-  REAL, DIMENSION(iim, jjphy_nb) :: wri_windsp
+  real, dimension(iim, jj_nb) :: wri_sol_ice, wri_sol_sea, wri_nsol_ice 
+  real, dimension(iim, jj_nb) :: wri_nsol_sea, wri_fder_ice, wri_evap_ice
+  REAL, DIMENSION(iim, jj_nb) :: wri_evap_sea, wri_rcoa, wri_rriv
+  REAL, DIMENSION(iim, jj_nb) :: wri_rain, wri_snow, wri_taux, wri_tauy
+  REAL, DIMENSION(iim, jj_nb) :: wri_calv
+  REAL, DIMENSION(iim, jj_nb) :: wri_tauxx, wri_tauyy, wri_tauzz
+  REAL, DIMENSION(iim, jj_nb) :: tmp_lon, tmp_lat
+  REAL, DIMENSION(iim, jj_nb) :: wri_windsp
 
 ! variables relues par le coupleur
@@ -1793,8 +1789,8 @@
 ! l'avoir lu
   real, allocatable,dimension(:,:),save :: pctsrf_sav
-  real, dimension(iim, jjphy_nb, 3) :: tamp_srf
+  real, dimension(iim, jj_nb, 3) :: tamp_srf
   integer, allocatable, dimension(:), save :: tamp_ind
   real, allocatable, dimension(:,:),save :: tamp_zmasq
-  real, dimension(iim, jjphy_nb) :: deno
+  real, dimension(iim, jj_nb) :: deno
   integer                     :: idtime
   integer, allocatable,dimension(:),save :: unity
@@ -1870,7 +1866,7 @@
 !ym    ALLOCATE(cpl_rcoa(iim,jjm+1), stat=error); sum_error = sum_error + error
 !ym    ALLOCATE(cpl_rlic(iim,jjm+1), stat=error); sum_error = sum_error + error
-    ALLOCATE(cpl_rriv(iim,jjphy_nb), stat=error); sum_error = sum_error + error
-    ALLOCATE(cpl_rcoa(iim,jjphy_nb), stat=error); sum_error = sum_error + error
-    ALLOCATE(cpl_rlic(iim,jjphy_nb), stat=error); sum_error = sum_error + error
+    ALLOCATE(cpl_rriv(iim,jj_nb), stat=error); sum_error = sum_error + error
+    ALLOCATE(cpl_rcoa(iim,jj_nb), stat=error); sum_error = sum_error + error
+    ALLOCATE(cpl_rlic(iim,jj_nb), stat=error); sum_error = sum_error + error
 
 
@@ -1880,8 +1876,8 @@
 !ym    allocate(read_sit(iim, jjm+1), stat = error); sum_error = sum_error + error
 !ym    allocate(read_alb_sic(iim, jjm+1), stat = error); sum_error = sum_error + error
-    allocate(read_sst(iim, jjphy_nb), stat = error); sum_error = sum_error + error
-    allocate(read_sic(iim, jjphy_nb), stat = error); sum_error = sum_error + error
-    allocate(read_sit(iim, jjphy_nb), stat = error); sum_error = sum_error + error
-    allocate(read_alb_sic(iim, jjphy_nb), stat = error); sum_error = sum_error + error
+    allocate(read_sst(iim, jj_nb), stat = error); sum_error = sum_error + error
+    allocate(read_sic(iim, jj_nb), stat = error); sum_error = sum_error + error
+    allocate(read_sit(iim, jj_nb), stat = error); sum_error = sum_error + error
+    allocate(read_alb_sic(iim, jj_nb), stat = error); sum_error = sum_error + error
     read_sst=0.
     read_sic=0.
@@ -1902,5 +1898,5 @@
     allocate(tamp_ind(klon), stat = error); sum_error = sum_error + error
 !ym    allocate(tamp_zmasq(iim, jjm+1), stat = error); sum_error = sum_error + error    
-    allocate(tamp_zmasq(iim, jjphy_nb), stat = error); sum_error = sum_error + error    
+    allocate(tamp_zmasq(iim, jj_nb), stat = error); sum_error = sum_error + error    
     tamp_zmasq=1.
     
@@ -1908,5 +1904,5 @@
       tamp_ind(ig) = ig
     enddo
-    call gath2cpl(zmasq, tamp_zmasq, klon, klon, iim, jjphy_nb, tamp_ind)
+    call gath2cpl(zmasq, tamp_zmasq, klon, klon, iim, jj_nb, tamp_ind)
 !
 ! initialisation couplage
@@ -1917,5 +1913,5 @@
    CALL inicma(iim, (jjm+1))
 #else
-   if (.not. monocpu) then
+   if (is_parallel) then
       abort_message='coupleur parallele uniquement avec PSMILE'
       call abort_gcm(modname,abort_message,1)
@@ -1928,5 +1924,5 @@
 !
  !ym  IO de check deconnecte pour le moment en //
-    IF (monocpu) THEN
+    IF (is_sequential) THEN
     idayref = day_ini
     CALL ymds2ju(annee_ref, 1, idayref, 0.0, zjulian)
@@ -2049,8 +2045,8 @@
 #ifdef CPP_PSMILE
       il_time_secs=(itime-1)*dtime
-      CALL fromcpl(il_time_secs, iim, jjphy_nb,                           &
+      CALL fromcpl(il_time_secs, iim, jj_nb,                           &
      &        read_sst, read_sic, read_sit, read_alb_sic)
 #else
-     if (.not. monocpu) then
+     if (is_parallel) then
         abort_message='coupleur parallele uniquement avec PSMILE'
         call abort_gcm(modname,abort_message,1)
@@ -2064,5 +2060,5 @@
 ! sorties NETCDF des champs recus
 !
-     if (monocpu) THEN
+     if (is_sequential) THEN
        ndexcs(:)=0
        itau_w = itau_phy + itime
@@ -2076,5 +2072,5 @@
 
 !ym      do j = 1, jjm + 1
-       do j = 1, jjphy_nb
+       do j = 1, jj_nb
          do ig = 1, iim
           if (abs(1. - read_sic(ig,j)) < 0.00001) then
@@ -2096,5 +2092,5 @@
 ! transformer read_sic en pctsrf_sav
 !
-      call cpl2gath(read_sic, tamp_sic , klon, klon,iim,jjphy_nb, unity)
+      call cpl2gath(read_sic, tamp_sic , klon, klon,iim,jj_nb, unity)
       do ig = 1, klon
         IF (pctsrf(ig,is_oce) > epsfra .OR.            &
@@ -2139,16 +2135,16 @@
     if (nisurf == is_oce .and. (.not. cumul) ) then
       sum_error = 0
-      allocate(tmp_sols(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_nsol(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_rain(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_snow(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_evap(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_tsol(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_fder(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_albe(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_taux(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
-      allocate(tmp_tauy(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
-! -- LOOP
-       allocate(tmp_windsp(iim,jjphy_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_sols(iim,jj_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_nsol(iim,jj_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_rain(iim,jj_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_snow(iim,jj_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_evap(iim,jj_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_tsol(iim,jj_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_fder(iim,jj_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_albe(iim,jj_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_taux(iim,jj_nb,2), stat=error); sum_error = sum_error + error
+      allocate(tmp_tauy(iim,jj_nb,2), stat=error); sum_error = sum_error + error
+! -- LOOP
+       allocate(tmp_windsp(iim,jj_nb,2), stat=error); sum_error = sum_error + error
 ! -- LOOP
 !!$      allocate(tmp_rriv(iim,jjm+1,2), stat=error); sum_error = sum_error + error
@@ -2165,16 +2161,16 @@
     cpl_index = 1
     if (nisurf == is_sic) cpl_index = 2
-    call gath2cpl(cpl_sols(1,cpl_index), tmp_sols(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
-    call gath2cpl(cpl_nsol(1,cpl_index), tmp_nsol(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
-    call gath2cpl(cpl_rain(1,cpl_index), tmp_rain(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
-    call gath2cpl(cpl_snow(1,cpl_index), tmp_snow(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
-    call gath2cpl(cpl_evap(1,cpl_index), tmp_evap(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
-    call gath2cpl(cpl_tsol(1,cpl_index), tmp_tsol(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
-    call gath2cpl(cpl_fder(1,cpl_index), tmp_fder(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
-    call gath2cpl(cpl_albe(1,cpl_index), tmp_albe(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
-    call gath2cpl(cpl_taux(1,cpl_index), tmp_taux(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
-    call gath2cpl(cpl_tauy(1,cpl_index), tmp_tauy(1,1,cpl_index), klon, knon,iim,jjphy_nb,                  knindex)
-! -- LOOP
-     call gath2cpl(cpl_windsp(1,cpl_index), tmp_windsp(1,1,cpl_index), klon, knon,iim,jjphy_nb,            knindex)
+    call gath2cpl(cpl_sols(1,cpl_index), tmp_sols(1,1,cpl_index), klon, knon,iim,jj_nb,                  knindex)
+    call gath2cpl(cpl_nsol(1,cpl_index), tmp_nsol(1,1,cpl_index), klon, knon,iim,jj_nb,                  knindex)
+    call gath2cpl(cpl_rain(1,cpl_index), tmp_rain(1,1,cpl_index), klon, knon,iim,jj_nb,                  knindex)
+    call gath2cpl(cpl_snow(1,cpl_index), tmp_snow(1,1,cpl_index), klon, knon,iim,jj_nb,                  knindex)
+    call gath2cpl(cpl_evap(1,cpl_index), tmp_evap(1,1,cpl_index), klon, knon,iim,jj_nb,                  knindex)
+    call gath2cpl(cpl_tsol(1,cpl_index), tmp_tsol(1,1,cpl_index), klon, knon,iim,jj_nb,                  knindex)
+    call gath2cpl(cpl_fder(1,cpl_index), tmp_fder(1,1,cpl_index), klon, knon,iim,jj_nb,                  knindex)
+    call gath2cpl(cpl_albe(1,cpl_index), tmp_albe(1,1,cpl_index), klon, knon,iim,jj_nb,                  knindex)
+    call gath2cpl(cpl_taux(1,cpl_index), tmp_taux(1,1,cpl_index), klon, knon,iim,jj_nb,                  knindex)
+    call gath2cpl(cpl_tauy(1,cpl_index), tmp_tauy(1,1,cpl_index), klon, knon,iim,jj_nb,                  knindex)
+! -- LOOP
+     call gath2cpl(cpl_windsp(1,cpl_index), tmp_windsp(1,1,cpl_index), klon, knon,iim,jj_nb,            knindex)
 ! -- LOOP
 
@@ -2188,6 +2184,6 @@
        wri_windsp = 0.
 ! -- LOOP      
-      call gath2cpl(pctsrf(1,is_oce), tamp_srf(1,1,1), klon, klon, iim, jjphy_nb, tamp_ind)
-      call gath2cpl(pctsrf(1,is_sic), tamp_srf(1,1,2), klon, klon, iim, jjphy_nb, tamp_ind)
+      call gath2cpl(pctsrf(1,is_oce), tamp_srf(1,1,1), klon, klon, iim, jj_nb, tamp_ind)
+      call gath2cpl(pctsrf(1,is_sic), tamp_srf(1,1,2), klon, klon, iim, jj_nb, tamp_ind)
 
       wri_sol_ice = tmp_sols(:,:,2)
@@ -2214,9 +2210,9 @@
 !Essai OM+JLD : ca marche !!!! (17 mars 2006)
       tamp_srf(:,:,3)=0.
-      CALL gath2cpl( pctsrf(1,is_lic), tamp_srf(1,1,3), klon, klon, iim, jjphy_nb, tamp_ind)
+      CALL gath2cpl( pctsrf(1,is_lic), tamp_srf(1,1,3), klon, klon, iim, jj_nb, tamp_ind)
 
 !YM pour retrouver resultat avant tamp_srf(:,3)=1.
       
-      DO j = 1, jjphy_nb
+      DO j = 1, jj_nb
          wri_calv(:,j) = DOT_PRODUCT (cpl_rlic(1:iim,j), tamp_srf(1:iim,j,3)) / REAL(iim)
       ENDDO
@@ -2227,27 +2223,27 @@
 !ym      enddo
 
-      IF (.NOT. monocpu) THEN
-        if (phy_rank /= 0) then
+      IF (is_parallel) THEN
+        if (.NOT.is_north_pole) then
 #ifdef CPP_PARA
-          call MPI_RECV(Up,1,MPI_REAL8,phy_rank-1,1234,COMM_LMDZ,status,ierr)
-          call MPI_SEND(wri_calv(1,1),1,MPI_REAL8,phy_rank-1,1234,COMM_LMDZ,ierr)
+          call MPI_RECV(Up,1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,status,ierr)
+          call MPI_SEND(wri_calv(1,1),1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,ierr)
 #endif
         endif
         
-        if (phy_rank /= phy_size-1) then
+        if (.NOT.is_south_pole) then
 #ifdef CPP_PARA
-          call MPI_SEND(wri_calv(1,jjphy_nb),1,MPI_REAL8,phy_rank+1,1234,COMM_LMDZ,ierr)  
-          call MPI_RECV(down,1,MPI_REAL8,phy_rank+1,1234,COMM_LMDZ,status,ierr)
+          call MPI_SEND(wri_calv(1,jj_nb),1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,ierr)  
+          call MPI_RECV(down,1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,status,ierr)
 #endif
         endif
   	
-        if (phy_rank /=0 .and. iiphy_begin /=1) then
+        if (mpi_rank /=0 .and. ii_begin /=1) then
           Up=Up+wri_calv(iim,1)
 	  wri_calv(:,1)=Up
         endif
       
-        if (phy_rank /=phy_size-1 .and. iiphy_end /= iim) then
-          Down=Down+wri_calv(1,jjphy_nb)
-	  wri_calv(:,jjphy_nb)=Down	 
+        if (mpi_rank /=mpi_size-1 .and. ii_end /= iim) then
+          Down=Down+wri_calv(1,jj_nb)
+	  wri_calv(:,jj_nb)=Down	 
         endif
       ENDIF
@@ -2277,16 +2273,22 @@
 !ym      CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,tmp_lat)
 
-      CALL phy2dyn(rlon,tmp_lon,1)
-      CALL phy2dyn(rlat,tmp_lat,1)
-      
-!ym      DO i = 1, iim
-!ym        tmp_lon(i,1) = rlon(i+1)
-!ym        tmp_lon(i,jjm + 1) = rlon(i+1)
-!ym      ENDDO
-
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!!! ATENTION A NE PAS OUBLIER
+!!! REMPLACER phy2dyn par grid1DTo2D_mpi
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+       CALL Grid1DTo2D_mpi(rlon,tmp_lon)
+       CALL Grid1DTo2D_mpi(rlat,tmp_lat)
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+     IF (is_sequential) THEN
+       IF (is_north_pole) tmp_lon(:,1) = tmp_lon(:,2)
+       IF (is_south_pole) tmp_lon(:,jjm + 1) = tmp_lon(:,jjm)
+     ENDIF
 !
 ! sortie netcdf des champs pour le changement de repere
 !
-      IF (monocpu) THEN
+      IF (is_sequential) THEN
         ndexct(:)=0
         CALL histwrite(nidct,'tauxe',itau_w,wri_taux,iim*(jjm+1),ndexct)
@@ -2298,5 +2300,5 @@
 ! calcul 3 coordonnees du vent
 !
-      CALL atm2geo (iim , jjphy_nb, wri_taux, wri_tauy, tmp_lon, tmp_lat, &
+      CALL atm2geo (iim , jj_nb, wri_taux, wri_tauy, tmp_lon, tmp_lat, &
          & wri_tauxx, wri_tauyy, wri_tauzz )
 !
@@ -2304,5 +2306,5 @@
 ! envoi au coupleur
 !
-    IF (monocpu) THEN
+    IF (is_sequential) THEN
       CALL histwrite(nidct,cl_writ(8),itau_w,wri_sol_ice,iim*(jjm+1),ndexct)
       CALL histwrite(nidct,cl_writ(9),itau_w,wri_sol_sea,iim*(jjm+1),ndexct)
@@ -2389,8 +2391,8 @@
 !
   if (nisurf == is_oce) then
-    call cpl2gath(read_sst, tsurf_new, klon, knon,iim,jjphy_nb, knindex)
+    call cpl2gath(read_sst, tsurf_new, klon, knon,iim,jj_nb, knindex)
   else if (nisurf == is_sic) then
-    call cpl2gath(read_sit, tsurf_new, klon, knon,iim,jjphy_nb, knindex)
-    call cpl2gath(read_alb_sic, alb_new, klon, knon,iim,jjphy_nb, knindex)
+    call cpl2gath(read_sit, tsurf_new, klon, knon,iim,jj_nb, knindex)
+    call cpl2gath(read_alb_sic, alb_new, klon, knon,iim,jj_nb, knindex)
   endif
   pctsrf_new(:,nisurf) = pctsrf_sav(:,nisurf)
@@ -2667,10 +2669,10 @@
 !
   SUBROUTINE interfoce_lim(itime, dtime, jour, &
-     & klon_xx, nisurf, knon, knindex, &
+     & klon, nisurf, knon, knindex, &
      & debut,  &
      & lmt_sst_p, pctsrf_new_p)
      
-     USE dimphy,klon=>klon2,klon2=>klon
-
+     USE mod_grid_phy_lmdz
+     USE mod_phys_lmdz_para
 #include "indicesol.inc"
 
@@ -2700,16 +2702,16 @@
   real   , intent(IN) :: dtime
   integer, intent(IN) :: jour
-  integer, intent(in) :: klon_xx
+  integer, intent(in) :: klon
   integer, intent(IN) :: nisurf
   integer, intent(IN) :: knon
-  integer, dimension(klon2), intent(in) :: knindex
+  integer, dimension(klon_loc), intent(in) :: knindex
   logical, intent(IN) :: debut
 
 ! Parametres de sortie
-  real, intent(out), dimension(klon2) :: lmt_sst_p
-  real, intent(out), dimension(klon2,nbsrf) :: pctsrf_new_p
+  real, intent(out), dimension(klon_loc) :: lmt_sst_p
+  real, intent(out), dimension(klon_loc,nbsrf) :: pctsrf_new_p
 
 !  real, dimension(klon) :: lmt_sst
-  real, dimension(klon,nbsrf) :: pctsrf_new
+  real, dimension(klon_glo,nbsrf) :: pctsrf_new
 
 ! Variables locales
@@ -2735,12 +2737,10 @@
   real, allocatable , save, dimension(:) :: sst_lu_p
 !$OMP THREADPRIVATE(sst_lu_p)
-  real, allocatable , save, dimension(:) :: sst_lu_mpi
 
   real, allocatable , save, dimension(:,:) :: pct_tmp_p
 !$OMP THREADPRIVATE(pct_tmp_p)
-  real, allocatable , save, dimension(:,:) :: pct_tmp_mpi
-  real, dimension(klon,nbsrf) :: pct_tmp
-  real, dimension(klon) :: sst_lu
-  real, dimension(klon) :: nat_lu
+  real, dimension(klon_glo,nbsrf) :: pct_tmp
+  real, dimension(klon_glo) :: sst_lu
+  real, dimension(klon_glo) :: nat_lu
 !
 ! quelques variables pour netcdf
@@ -2756,6 +2756,6 @@
     lmt_pas = nint(86400./dtime * 1.0) ! pour une lecture une fois par jour
     jour_lu = jour - 1
-    allocate(sst_lu_p(klon_omp))
-    allocate(pct_tmp_p(klon_omp,nbsrf))
+    allocate(sst_lu_p(klon_loc))
+    allocate(pct_tmp_p(klon_loc,nbsrf))
   endif
 
@@ -2771,8 +2771,5 @@
 !
 !$OMP MASTER
-    if (.not. allocated(sst_lu_mpi)) allocate(sst_lu_mpi(klon_mpi))
-    if (.not. allocated(pct_tmp_mpi)) allocate(pct_tmp_mpi(klon_mpi,nbsrf))
-    
-    if (phy_rank==0) then
+    if (is_mpi_root) then
     
     fich = trim(fich)
@@ -2787,5 +2784,5 @@
     start(1) = 1
     start(2) = jour
-    epais(1) = klon
+    epais(1) = klon_glo
     epais(2) = 1
 !
@@ -2881,5 +2878,5 @@
 ! 
       pct_tmp = 0.0
-      do ii = 1, klon
+      do ii = 1, klon_glo
         pct_tmp(ii,nint(nat_lu(ii)) + 1) = 1.
       enddo
@@ -2915,19 +2912,18 @@
 !
     ierr = NF_CLOSE(nid)
-   endif ! phyrank
-!
-! Recopie des variables dans les champs de sortie
-!
-  call ScatterField(sst_lu,sst_lu_mpi,1)
-  call ScatterField(pct_tmp(:,is_oce),pct_tmp_mpi(:,is_oce),1)
-  call ScatterField(pct_tmp(:,is_sic),pct_tmp_mpi(:,is_sic),1)
+   endif ! is_mpi_root
+
 !$OMP END MASTER
 !$OMP BARRIER
-  call ScatterField_omp(sst_lu_mpi,sst_lu_p,1)
-  call ScatterField_omp(pct_tmp_mpi(:,is_oce),pct_tmp_p(:,is_oce),1)
-  call ScatterField_omp(pct_tmp_mpi(:,is_sic),pct_tmp_p(:,is_sic),1)
+  call Scatter(sst_lu,sst_lu_p)
+  call Scatter(pct_tmp(:,is_oce),pct_tmp_p(:,is_oce))
+  call Scatter(pct_tmp(:,is_sic),pct_tmp_p(:,is_sic))
    deja_lu = .true.
    jour_lu = jour
   endif   
+
+!
+! Recopie des variables dans les champs de sortie
+!
   
   lmt_sst_p = 999999999.
@@ -2937,5 +2933,5 @@
   enddo
 
-  do ii=1,klon2
+  do ii=1,klon_loc
     pctsrf_new_p(ii,is_oce)=pct_tmp_p(ii,is_oce)
     pctsrf_new_p(ii,is_sic)=pct_tmp_p(ii,is_sic)
@@ -2949,10 +2945,11 @@
 !
   SUBROUTINE interfsur_lim(itime, dtime, jour, &
-     & klon_xx, nisurf, knon, knindex, &
+     & klon, nisurf, knon, knindex, &
      & debut,  &
      & lmt_alb_p, lmt_rug_p)
 
-     USE dimphy,klon=>klon2,klon2=>klon
-
+     USE mod_grid_phy_lmdz
+     USE mod_phys_lmdz_para
+     
 ! Cette routine sert d'interface entre le modele atmospherique et un fichier
 ! de conditions aux limites
@@ -2984,11 +2981,11 @@
   integer, intent(IN) :: nisurf
   integer, intent(IN) :: knon
-  integer, intent(IN) :: klon_xx
-  integer, dimension(klon2), intent(in) :: knindex
+  integer, intent(IN) :: klon
+  integer, dimension(klon_loc), intent(in) :: knindex
   logical, intent(IN) :: debut
 
 ! Parametres de sortie
-  real, intent(out), dimension(klon2) :: lmt_alb_p
-  real, intent(out), dimension(klon2) :: lmt_rug_p
+  real, intent(out), dimension(klon_loc) :: lmt_alb_p
+  real, intent(out), dimension(klon_loc) :: lmt_rug_p
 
 !  real,  dimension(klon) :: lmt_alb
@@ -3017,6 +3014,5 @@
   real, allocatable , save, dimension(:) :: alb_lu_p, rug_lu_p
 !$OMP THREADPRIVATE(alb_lu_p, rug_lu_p) 
-  real, allocatable , save, dimension(:) :: alb_lu_mpi, rug_lu_mpi
-  real, dimension(klon) :: alb_lu, rug_lu
+  real, dimension(klon_glo) :: alb_lu, rug_lu
 !
 ! quelques variables pour netcdf
@@ -3034,6 +3030,6 @@
     lmt_pas = nint(86400./dtime * 1.0) ! pour une lecture une fois par jour
     jour_lu_sur = jour - 1
-    allocate(alb_lu_p(klon_omp))
-    allocate(rug_lu_p(klon_omp))
+    allocate(alb_lu_p(klon_loc))
+    allocate(rug_lu_p(klon_loc))
   endif
 
@@ -3048,7 +3044,5 @@
 
 !$OMP MASTER
-    if (.not. allocated(alb_lu_mpi)) allocate(alb_lu_mpi(klon_mpi))
-    if (.not. allocated(rug_lu_mpi)) allocate(rug_lu_mpi(klon_mpi))  
-  if (phy_rank==0) then
+   if (is_mpi_root) then
 !
 ! Ouverture du fichier
@@ -3067,5 +3061,5 @@
     start(1) = 1
     start(2) = jour
-    epais(1) = klon
+    epais(1) = klon_glo
     epais(2) = 1
 !
@@ -3109,13 +3103,9 @@
 
 
-  endif  !! phyrank
-
-    call ScatterField(alb_lu,alb_lu_mpi,1)
-    call ScatterField(rug_lu,rug_lu_mpi,1)
+  endif  !! is_mpi_root
 !$OMP END MASTER
-!$OMP BARRIER
-
-    call ScatterField_omp(alb_lu_mpi,alb_lu_p,1)
-    call ScatterField_omp(rug_lu_mpi,rug_lu_p,1)
+
+    call Scatter(alb_lu,alb_lu_p)
+    call Scatter(rug_lu,rug_lu_p)
     
     deja_lu_sur = .true.
@@ -3151,5 +3141,5 @@
      & petAcoef, peqAcoef, petBcoef, peqBcoef, &
      & tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
-     USE dimphy,only : omp_rank
+
 ! Cette routine calcule les fluxs en h et q a l'interface et eventuellement
 ! une temperature de surface (au cas ou ok_veget = false)
@@ -3385,5 +3375,5 @@
 !
   SUBROUTINE gath2cpl(champ_in, champ_out, klon, knon, iim, jmp1, knindex)
-  use dimphy, only: liste_i,liste_j,jjphy_begin,jjphy_nb,phy_rank,phy_size 
+  USE mod_phys_lmdz_para
   implicit none
   
@@ -3404,11 +3394,11 @@
 ! input
   integer                   :: klon, knon, iim, jmp1
-  real, dimension(klon)     :: champ_in
-  integer, dimension(klon)  :: knindex
+  real, dimension(klon_loc)     :: champ_in
+  integer, dimension(klon_loc)  :: knindex
 ! output
   real, dimension(iim,jmp1)  :: champ_out
 ! local
   integer                   :: i, ig, j
-  real, dimension(klon)     :: tamp
+  real, dimension(klon_loc)     :: tamp
 
   tamp = 0.
@@ -3418,23 +3408,6 @@
   enddo    
 
-!ym  ig = 1
-!ym  champ_out(:,1) = tamp(ig)
-!ym  do j = 2, jjm
-!ym    do i = 1, iim
-!ym      ig = ig + 1
-!ym      champ_out(i,j) = tamp(ig)
-!ym    enddo
-!ym  enddo
-!ym  ig = ig + 1
-!ym  champ_out(:,jjm+1) = tamp(ig)
-
-  do ig=1,klon
-    i=liste_i(ig)
-    j=liste_j(ig)-jjphy_begin+1
-    champ_out(i,j)=tamp(ig)
-  enddo
-  
-  if (phy_rank==0) champ_out(:,1)=tamp(1)
-  if (phy_rank==phy_size-1) champ_out(:,jjphy_nb)=tamp(klon)
+
+  CALL Grid1Dto2D_mpi(tamp,champ_out)
 
   END SUBROUTINE gath2cpl
@@ -3443,5 +3416,5 @@
 !
   SUBROUTINE cpl2gath(champ_in, champ_out, klon, knon, iim, jmp1, knindex)
-  use dimphy, only : liste_i, liste_j, jjphy_begin
+  USE mod_phys_lmdz_para
   implicit none
 ! Cette routine ecrit un champ 'gathered' sur la grille 2D pour le passer
@@ -3462,29 +3435,14 @@
   integer                   :: klon, knon, iim, jmp1
   real, dimension(iim,jmp1)     :: champ_in
-  integer, dimension(klon)  :: knindex
+  integer, dimension(klon_loc)  :: knindex
 ! output
-  real, dimension(klon)  :: champ_out
+  real, dimension(klon_loc)  :: champ_out
 ! local
   integer                   :: i, ig, j
-  real, dimension(klon)     :: tamp
+  real, dimension(klon_loc)     :: tamp
   logical ,save                  :: check = .false.
 !$OMP THREADPRIVATE(check)
 
-!ym  ig = 1
-!ym  tamp(ig) = champ_in(1,1)
-!ym  do j = 2, jjm
-!ym    do i = 1, iim
-!ym      ig = ig + 1
-!ym      tamp(ig) = champ_in(i,j)
-!ym    enddo
-!ym  enddo
-!ym  ig = ig + 1
-!ym  tamp(ig) = champ_in(1,jjm+1)
-
-  do ig=1,klon
-   i=liste_i(ig)
-   j=liste_j(ig)-jjphy_begin+1
-   tamp(ig)=champ_in(i,j)
-  enddo
+  CALL Grid2Dto1D_mpi(champ_in,tamp)
   
   do i = 1, knon
